(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('s-rxjs-utils'), require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/forms'), require('micro-dash')) :
    typeof define === 'function' && define.amd ? define('s-ng-utils', ['exports', 's-rxjs-utils', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/forms', 'micro-dash'], factory) :
    (global = global || self, factory(global['s-ng-utils'] = {}, global.sRxjsUtils, global.ng.core, global.rxjs, global.rxjs.operators, global.ng.forms, global.microDash));
}(this, function (exports, sRxjsUtils, core, rxjs, operators, forms, microDash) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Use as the superclass for anything managed by angular's dependency injection for care-free use of `subscribeTo()`. It simply calls `unsubscribe()` during `ngOnDestroy()`. If you override `ngOnDestroy()` in your subclass, be sure to invoke the super implementation.
     *
     * ```ts
     * \@Injectable()
     * // or \@Component() (also consider DirectiveSuperclass)
     * // or \@Directive() (also consider DirectiveSuperclass)
     * // or \@Pipe()
     * class MyThing extends AutoDestroyable {
     *   constructor(somethingObservable: Observable) {
     *     super();
     *     this.subscribeTo(somethingObservable);
     *   }
     *
     *   ngOnDestroy() {
     *     // if you override ngOnDestroy, be sure to call this too
     *     super.ngOnDestroy();
     *   }
     * }
     * ```
     * @abstract
     */
    var   /**
     * Use as the superclass for anything managed by angular's dependency injection for care-free use of `subscribeTo()`. It simply calls `unsubscribe()` during `ngOnDestroy()`. If you override `ngOnDestroy()` in your subclass, be sure to invoke the super implementation.
     *
     * ```ts
     * \@Injectable()
     * // or \@Component() (also consider DirectiveSuperclass)
     * // or \@Directive() (also consider DirectiveSuperclass)
     * // or \@Pipe()
     * class MyThing extends AutoDestroyable {
     *   constructor(somethingObservable: Observable) {
     *     super();
     *     this.subscribeTo(somethingObservable);
     *   }
     *
     *   ngOnDestroy() {
     *     // if you override ngOnDestroy, be sure to call this too
     *     super.ngOnDestroy();
     *   }
     * }
     * ```
     * @abstract
     */
    AutoDestroyable = /** @class */ (function (_super) {
        __extends(AutoDestroyable, _super);
        function AutoDestroyable() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @return {?}
         */
        AutoDestroyable.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.unsubscribe();
        };
        return AutoDestroyable;
    }(sRxjsUtils.SubscriptionManager));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Extend this when creating a directive (including a component, which is a kind of directive) to gain access to the helpers demonstrated below. **Warning:** You _must_ include a constructor in your subclass.
     *
     * ```ts
     * \@Component({
     *   selector: "s-color-text",
     *   template: `
     *     <span [style.background]="color">{{ color }}</span>
     *   `,
     *   // note that `bindToInstance()` works even with OnPush change detection
     *   changeDetection: ChangeDetectionStrategy.OnPush,
     * })
     *  class ColorTextComponent extends DirectiveSuperclass {
     * \@Input() prefix?: string;
     * \@Input() prefix2?: string;
     *   color!: string;
     *
     *   // Even if you don't need extra arguments injector, you must still include a constructor. It is required for angular to provide `Injector`.
     *   constructor(
     * \@Inject("color$") color$: Observable<string>,
     *     injector: Injector,
     *   ) {
     *     super(injector);
     *
     *     // combine everything to calculate `color` and keep it up to date
     *     this.bindToInstance(
     *       "color",
     *       combineLatest(
     *         this.getInput$("prefix"),
     *         this.getInput$("prefix2"),
     *         color$,
     *       ).pipe(map((parts) => parts.filter((p) => p).join(""))),
     *     );
     *   }
     * }
     * ```
     * @abstract
     */
    var   /**
     * Extend this when creating a directive (including a component, which is a kind of directive) to gain access to the helpers demonstrated below. **Warning:** You _must_ include a constructor in your subclass.
     *
     * ```ts
     * \@Component({
     *   selector: "s-color-text",
     *   template: `
     *     <span [style.background]="color">{{ color }}</span>
     *   `,
     *   // note that `bindToInstance()` works even with OnPush change detection
     *   changeDetection: ChangeDetectionStrategy.OnPush,
     * })
     *  class ColorTextComponent extends DirectiveSuperclass {
     * \@Input() prefix?: string;
     * \@Input() prefix2?: string;
     *   color!: string;
     *
     *   // Even if you don't need extra arguments injector, you must still include a constructor. It is required for angular to provide `Injector`.
     *   constructor(
     * \@Inject("color$") color$: Observable<string>,
     *     injector: Injector,
     *   ) {
     *     super(injector);
     *
     *     // combine everything to calculate `color` and keep it up to date
     *     this.bindToInstance(
     *       "color",
     *       combineLatest(
     *         this.getInput$("prefix"),
     *         this.getInput$("prefix2"),
     *         color$,
     *       ).pipe(map((parts) => parts.filter((p) => p).join(""))),
     *     );
     *   }
     * }
     * ```
     * @abstract
     */
    DirectiveSuperclass = /** @class */ (function (_super) {
        __extends(DirectiveSuperclass, _super);
        function DirectiveSuperclass(injector) {
            var _this = _super.call(this) || this;
            /**
             * Emits the set of `\@Input()` property names that change during each call to `ngOnChanges()`.
             */
            // lastChangedKeys$ = new Subject<Set<keyof this>>();
            _this.lastChangedKeys$ = new rxjs.BehaviorSubject(new Set());
            _this.changeDetectorRef = injector.get(core.ChangeDetectorRef);
            return _this;
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        DirectiveSuperclass.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            this.lastChangedKeys$.next(new Set((/** @type {?} */ (Object.getOwnPropertyNames(changes)))));
        };
        /**
         * @return an observable of the values for one of this directive's `@Input()` properties
         */
        /**
         * @template K
         * @param {?} key
         * @return {?} an observable of the values for one of this directive's `\@Input()` properties
         */
        DirectiveSuperclass.prototype.getInput$ = /**
         * @template K
         * @param {?} key
         * @return {?} an observable of the values for one of this directive's `\@Input()` properties
         */
        function (key) {
            var _this = this;
            return this.lastChangedKeys$.pipe(operators.filter((/**
             * @param {?} keys
             * @return {?}
             */
            function (keys) { return keys.has(key); })), operators.map((/**
             * @return {?}
             */
            function () { return _this[key]; })));
        };
        /**
         * Binds an observable to one of this directive's instance variables. When the observable emits the instance variable will be updated, and change detection will be triggered to propagate any changes. Use this an an alternative to repeating `| async` multiple times in your template.
         */
        /**
         * Binds an observable to one of this directive's instance variables. When the observable emits the instance variable will be updated, and change detection will be triggered to propagate any changes. Use this an an alternative to repeating `| async` multiple times in your template.
         * @template K
         * @param {?} key
         * @param {?} value$
         * @return {?}
         */
        DirectiveSuperclass.prototype.bindToInstance = /**
         * Binds an observable to one of this directive's instance variables. When the observable emits the instance variable will be updated, and change detection will be triggered to propagate any changes. Use this an an alternative to repeating `| async` multiple times in your template.
         * @template K
         * @param {?} key
         * @param {?} value$
         * @return {?}
         */
        function (key, value$) {
            var _this = this;
            this.subscribeTo(value$, (/**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                _this[key] = value;
                _this.changeDetectorRef.markForCheck();
            }));
        };
        return DirectiveSuperclass;
    }(AutoDestroyable));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Use in the `providers` of a component that implements `ControlValueAccessor` to reduce some boilerplate.
     *
     * ```ts
     * \@Component({ providers: [provideValueAccessor(MyFormControl)] }
     * class MyFormControl extends BaseFormControl {
     *   // ...
     * }
     * ```
     * @param {?} type
     * @return {?}
     */
    function provideValueAccessor(type) {
        return {
            provide: forms.NG_VALUE_ACCESSOR,
            useExisting: type,
            multi: true,
        };
    }
    /**
     * Extend this when creating a form control to reduce some boilerplate. **Warning:** You _must_ include a constructor in your subclass.
     *
     * This example allows 2-way binding to a number via `[(ngModel)]`, `[formControl]`, or any other technique that leverages the `ControlValueAccessor` interface.
     * ```ts
     * \@Component({
     *   template: `
     *     <button (click)="increment()" [disabled]="isDisabled">{{ counter }}</button>
     *   `,
     *   providers: [provideValueAccessor(CounterComponent)],
     * })
     * class CounterComponent extends FormControlSuperclass<number> {
     *   counter = 0;
     *
     *   // This looks unnecessary, but is required for Angular to provide `Injector`
     *   constructor(injector: Injector) {
     *     super(injector);
     *   }
     *
     *   handleIncomingValue(value: number) {
     *     this.counter = value;
     *   }
     *
     *   increment() {
     *     this.emitOutgoingValue(++this.counter);
     *     this.onTouched();
     *   }
     * }
     * ```
     * @abstract
     * @template T
     */
    var   /**
     * Extend this when creating a form control to reduce some boilerplate. **Warning:** You _must_ include a constructor in your subclass.
     *
     * This example allows 2-way binding to a number via `[(ngModel)]`, `[formControl]`, or any other technique that leverages the `ControlValueAccessor` interface.
     * ```ts
     * \@Component({
     *   template: `
     *     <button (click)="increment()" [disabled]="isDisabled">{{ counter }}</button>
     *   `,
     *   providers: [provideValueAccessor(CounterComponent)],
     * })
     * class CounterComponent extends FormControlSuperclass<number> {
     *   counter = 0;
     *
     *   // This looks unnecessary, but is required for Angular to provide `Injector`
     *   constructor(injector: Injector) {
     *     super(injector);
     *   }
     *
     *   handleIncomingValue(value: number) {
     *     this.counter = value;
     *   }
     *
     *   increment() {
     *     this.emitOutgoingValue(++this.counter);
     *     this.onTouched();
     *   }
     * }
     * ```
     * @abstract
     * @template T
     */
    FormControlSuperclass = /** @class */ (function (_super) {
        __extends(FormControlSuperclass, _super);
        function FormControlSuperclass() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            /**
             * Call this to emit a new value when it changes.
             */
            _this.emitOutgoingValue = microDash.noop;
            /**
             * Call this to "commit" a change, traditionally done e.g. on blur.
             */
            _this.onTouched = microDash.noop;
            /**
             * You can bind to this in your template as needed.
             */
            _this.isDisabled = false;
            return _this;
        }
        /** Called as angular propagates value changes to this `ControlValueAccessor`. You normally do not need to use it. */
        /**
         * Called as angular propagates value changes to this `ControlValueAccessor`. You normally do not need to use it.
         * @param {?} value
         * @return {?}
         */
        FormControlSuperclass.prototype.writeValue = /**
         * Called as angular propagates value changes to this `ControlValueAccessor`. You normally do not need to use it.
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.handleIncomingValue(value);
            this.changeDetectorRef.markForCheck();
        };
        /** Called as angular sets up the binding to this `ControlValueAccessor`. You normally do not need to use it. */
        /**
         * Called as angular sets up the binding to this `ControlValueAccessor`. You normally do not need to use it.
         * @param {?} fn
         * @return {?}
         */
        FormControlSuperclass.prototype.registerOnChange = /**
         * Called as angular sets up the binding to this `ControlValueAccessor`. You normally do not need to use it.
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.emitOutgoingValue = fn;
        };
        /** Called as angular sets up the binding to this `ControlValueAccessor`. You normally do not need to use it. */
        /**
         * Called as angular sets up the binding to this `ControlValueAccessor`. You normally do not need to use it.
         * @param {?} fn
         * @return {?}
         */
        FormControlSuperclass.prototype.registerOnTouched = /**
         * Called as angular sets up the binding to this `ControlValueAccessor`. You normally do not need to use it.
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onTouched = fn;
        };
        /** Called as angular propagates disabled changes to this `ControlValueAccessor`. You normally do not need to use it. */
        /**
         * Called as angular propagates disabled changes to this `ControlValueAccessor`. You normally do not need to use it.
         * @param {?} isDisabled
         * @return {?}
         */
        FormControlSuperclass.prototype.setDisabledState = /**
         * Called as angular propagates disabled changes to this `ControlValueAccessor`. You normally do not need to use it.
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.isDisabled = isDisabled;
            this.changeDetectorRef.markForCheck();
        };
        return FormControlSuperclass;
    }(DirectiveSuperclass));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Extend this when creating a form control that simply wraps an existing form control, to reduce a lot of boilerplate. **Warning:** You _must_ include a constructor in your subclass.
     *
     * Example when you don't need to modify the wrapped control's value:
     * ```ts
     * \@Component({
     *   template: `<input [formControl]="formControl">`,
     *   providers: [provideValueAccessor(StringComponent)],
     * })
     * class StringComponent extends WrappedFormControlSuperclass<string> {
     *   // This looks unnecessary, but is required for Angular to provide `Injector`
     *   constructor(injector: Injector) {
     *     super(injector);
     *   }
     * }
     * ```
     *
     * Example when you need to modify the wrapped control's value:
     * ```ts
     * \@Component({
     *   template: `<input type="datetime-local" [formControl]="formControl">`,
     *   providers: [provideValueAccessor(DateComponent)],
     * })
     * class DateComponent extends WrappedFormControlSuperclass<Date, string> {
     *   // This looks unnecessary, but is required for Angular to provide `Injector`
     *   constructor(injector: Injector) {
     *     super(injector);
     *   }
     *
     *   protected innerToOuter(value: string): Date {
     *     return new Date(value + "Z");
     *   }
     *
     *   protected outerToInner(value: Date): string {
     *     if (value === null) {
     *       return ""; // happens during initialization
     *     }
     *     return value.toISOString().substr(0, 16);
     *   }
     * }
     * ```
     * @abstract
     * @template OuterType, InnerType
     */
    var   /**
     * Extend this when creating a form control that simply wraps an existing form control, to reduce a lot of boilerplate. **Warning:** You _must_ include a constructor in your subclass.
     *
     * Example when you don't need to modify the wrapped control's value:
     * ```ts
     * \@Component({
     *   template: `<input [formControl]="formControl">`,
     *   providers: [provideValueAccessor(StringComponent)],
     * })
     * class StringComponent extends WrappedFormControlSuperclass<string> {
     *   // This looks unnecessary, but is required for Angular to provide `Injector`
     *   constructor(injector: Injector) {
     *     super(injector);
     *   }
     * }
     * ```
     *
     * Example when you need to modify the wrapped control's value:
     * ```ts
     * \@Component({
     *   template: `<input type="datetime-local" [formControl]="formControl">`,
     *   providers: [provideValueAccessor(DateComponent)],
     * })
     * class DateComponent extends WrappedFormControlSuperclass<Date, string> {
     *   // This looks unnecessary, but is required for Angular to provide `Injector`
     *   constructor(injector: Injector) {
     *     super(injector);
     *   }
     *
     *   protected innerToOuter(value: string): Date {
     *     return new Date(value + "Z");
     *   }
     *
     *   protected outerToInner(value: Date): string {
     *     if (value === null) {
     *       return ""; // happens during initialization
     *     }
     *     return value.toISOString().substr(0, 16);
     *   }
     * }
     * ```
     * @abstract
     * @template OuterType, InnerType
     */
    WrappedFormControlSuperclass = /** @class */ (function (_super) {
        __extends(WrappedFormControlSuperclass, _super);
        function WrappedFormControlSuperclass(injector) {
            var _this = _super.call(this, injector) || this;
            /**
             * Bind this to your inner form control to make all the magic happen.
             */
            _this.formControl = new forms.FormControl();
            _this.subscribeTo(_this.formControl.valueChanges, (/**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                _this.emitOutgoingValue(_this.innerToOuter(value));
            }));
            _this.formControl.markAsTouched = (/**
             * @return {?}
             */
            function () {
                _this.onTouched();
            });
            return _this;
        }
        /** Called as angular propagates values changes to this `ControlValueAccessor`. You normally do not need to use it. */
        /**
         * Called as angular propagates values changes to this `ControlValueAccessor`. You normally do not need to use it.
         * @param {?} value
         * @return {?}
         */
        WrappedFormControlSuperclass.prototype.handleIncomingValue = /**
         * Called as angular propagates values changes to this `ControlValueAccessor`. You normally do not need to use it.
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.formControl.setValue(this.outerToInner(value), { emitEvent: false });
        };
        /** Called as angular propagates disabled changes to this `ControlValueAccessor`. You normally do not need to use it. */
        /**
         * Called as angular propagates disabled changes to this `ControlValueAccessor`. You normally do not need to use it.
         * @param {?} isDisabled
         * @return {?}
         */
        WrappedFormControlSuperclass.prototype.setDisabledState = /**
         * Called as angular propagates disabled changes to this `ControlValueAccessor`. You normally do not need to use it.
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            if (isDisabled) {
                this.formControl.disable({ emitEvent: false });
            }
            else {
                this.formControl.enable({ emitEvent: false });
            }
            _super.prototype.setDisabledState.call(this, this.isDisabled);
        };
        /** Override this to modify a value coming from the outside to the format needed within this component. */
        /**
         * Override this to modify a value coming from the outside to the format needed within this component.
         * @protected
         * @param {?} value
         * @return {?}
         */
        WrappedFormControlSuperclass.prototype.outerToInner = /**
         * Override this to modify a value coming from the outside to the format needed within this component.
         * @protected
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return (/** @type {?} */ (((/** @type {?} */ (value)))));
        };
        /** Override this to modify a value coming from within this component to the format expected on the outside. */
        /**
         * Override this to modify a value coming from within this component to the format expected on the outside.
         * @protected
         * @param {?} value
         * @return {?}
         */
        WrappedFormControlSuperclass.prototype.innerToOuter = /**
         * Override this to modify a value coming from within this component to the format expected on the outside.
         * @protected
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return (/** @type {?} */ (((/** @type {?} */ (value)))));
        };
        return WrappedFormControlSuperclass;
    }(FormControlSuperclass));

    exports.AutoDestroyable = AutoDestroyable;
    exports.DirectiveSuperclass = DirectiveSuperclass;
    exports.FormControlSuperclass = FormControlSuperclass;
    exports.WrappedFormControlSuperclass = WrappedFormControlSuperclass;
    exports.provideValueAccessor = provideValueAccessor;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=s-ng-utils.umd.js.map
